Instrucciones:
==============

En la carpeta edc:
------------------

make -> descargar y compilar uvvm y osvvm
make clean -> limpiar ficheros compilados
make realclean -> realiza lo anterior y además borra los sources de uvvm y osvvm


En la carpeta interpolator:
---------------------------

Pon tus ficheros fuente en src/ dentro de interpolator/

Se proporcionan 3 testbenches:
* tb_interpolator_simple.vhd (test sencillo, una interpolación)
* tb_interpolator_nocover.vhd (test complejo con UVVM y OSVVM)
* tb_interpolator_coverage.vhd (test complejo con functional coverage)

Sin embargo el Makefile espera encontrar un fichero, tb_interpolator.vhd.
Para empezar podemos copiar tb_interpolator_simple.vhd a tb_interpolator.vhd

Echa un vistazo al Makefile y modifica la variable objects dependiendo del
nombre de tus ficheros fuente

Para poder ejecutar y compilar el test, necesitas haber compilado anteriormente
uvvm y osvvm desde la carpeta edc

make -> compila y ejecuta el test, generando también un 'dump' de la forma de
onda y un informe de code coverage

make test -> ejecuta la simulación y genera los dump de forma de onda

make coverage -> genera el informe de code coverage

make syn -> realiza la sintesis utilizando yosys, y da error si encuentra
listas de sensibilidad incompletas o latches

gtkwave tb_interpolador.ghw para ver las formas de onda

Abre con un navegador coverage/index.html para ver el informe de code
coverage


En la carpeta bram:
-------------------

src/bram.vhd     : Código VHDL que implementa una memoria de bloque con un único puerto
src/tb_bram.vhd  : Testbench para el código anterior
src/dpram.vhd    : Código VHDL que implementa una memoria de bloque de doble puerto
src/tb_dpram.vhd : Testbench para el código anterior

make -> ejecuta los tests y genera el informe de code coverage

make test -> ejecuta los tests de ambas memorias

make coverage -> genera el informe de code coverage

make syn -> realiza la síntesis usando yosys y da un error si encuentra listas
de sensibilidad incompletas o latches


En la carpeta divider:
----------------------

Se proporciona el código VHDL que implementa un divisor de tamaño configurable.
El divisor tiene 2 generics, N y M, lo cuales determinan las anchuras de
los puertos:

* N es la anchura del dividendo y del cociente
* M es la anchura del divisor y del resto

src/divider.vhd           : Código VHDL del divisor
src/tb_divider.vhd        : Tests completo del divisor
src/tb_divider_simple.vhd : Testbench simplificado (simulable con ISim)

Al igual que en los diseños anteriores, se proporciona un Makefile para hacer
la síntesis y pasar los tests (mismos nombres de los targets que en los diseños
anteriores)


Documentación:
--------------

Para encontrar la documentación de UVVM y OSVVM, desde la carpeta edc:

find -iname "*.pdf"

De todos los packages que aparecen, estamos utilizando principalmente:
./uvvm_src/uvvm_util/doc/util_quick_ref.pdf
./osvvm_src/doc/RandomPkg_user_guide.pdf
./osvvm_src/doc/CoveragePkg_user_guide.pdf
